#!/bin/bash
# http://filezilla-project.org/
# http://filezilla-project.org/versions.php
# script : til <rob DOT til DOT freedman AT googlemail DOT com>
REPO=http://zenwalk.pinguix.com/user-accounts/tilderb
set -x -e -u

#filezilla
version=3.3.5
build=66.1
arch=i486
tune=i686

PKG_SRC="$REPO/extra/xap/filezilla/build-filezilla.sh
http://d10xg45o6p6dbl.cloudfront.net/projects/f/filezilla/FileZilla_${version}_src.tar.bz2"
PKG_DEP="atk,cairo,cxxlibs,dbus,expat,fontconfig,freetype,gcc,glib2,gnutls,gtk+2,libICE,libSM,libX11,libXau,libXcomposite,libXcursor,libXdamage,libXdmcp,libXext,libXfixes,libXi,libXinerama,libXrandr,libXrender,libXxf86vm,libgcrypt,libgpg-error,libidn,libjpeg,libpng,libtiff,libxcb,pango,pixman,sdl,svgalib,util-linux-ng,wxgtk,zlib"

pkgname=filezilla-$version
package=$pkgname-$arch-$build

CWD=$(pwd)
TMP=${TMP:-$CWD}
# build dirs
PKG=${TMP}/$package
SRC=${TMP}/$pkgname

# clean up
[ -d $PKG ] && rm -fr $PKG
[ -d $SRC ] && rm -fr $SRC

# make defaults
mkdir -p $PKG/{install,usr/{src,doc}/$pkgname}
mkdir -p $SRC
#
tar xf $CWD/FileZilla_${version}_src.tar.bz2 --strip-components=1 -C $SRC
cd $SRC
./configure --help >$CWD/configure--help

CXXFLAGS="-O2 -march=$arch -mtune=$tune " \
CFLAGS="-O2 -march=$arch -mtune=$tune " \
./configure \
    --prefix=/usr \
    --mandir=/usr/man \
    --docdir=/usr/doc/$pkgname \
    --disable-autoupdatecheck \
    --with-tinyxml=builtin
    
# --disable-locales     
# docdir vs. docsdir - typo or intentional?
sed -i 's:(pkgdatadir)/docs:(docdir):' Makefile
sed -i "s:/usr/share/filezilla/docs:/usr/doc/$pkgname:" docs/fzdefaults.xml.man

make || exit 1
make install DESTDIR=$PKG

# helper line 
(cd $PKG; find . -printf "%Y %M %u:%g %p\n" >$CWD/files)

# docs
cp -a AUTHORS COPYING ChangeLog GPL.html NEWS README  \
    $PKG/usr/doc/$pkgname
cd $PKG
# useless
rm -fr usr/share/pixmaps

# strip symbols
find usr/bin | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | \
    xargs -r strip --strip-unneeded 2> /dev/null

# put a slack-desc in place
cat <<EOF > install/slack-desc
         |-----handy-ruler------------------------------------------------------|
filezilla: filezilla (FTP/SFTP Client)
filezilla:
filezilla: FileZilla is a fast and reliable FTP client and server with lots of
filezilla: useful features and an intuitive interface.
EOF
# zip man pages
find usr/man -type f -name "*.?" | xargs gzip -9

# copy build script
cp $CWD/build-filezilla.sh usr/src/$pkgname

fakeroot /sbin/makepkg -l y -c n $CWD/$package.txz

cd $CWD
echo $PKG_DEP >$package.dep
#depfinder $PKG >$package.dep
echo "$PKG_SRC" >$package.src
md5sum $package.txz >$package.md5
